<!--
  Description: 变压器管理页面列表
  Author: 李亚光
  Date: 2023-05-29
 -->
<script lang="ts" setup name="network">
import { ElMessage, ElMessageBox } from 'element-plus'
import editList from './pageAdd.vue'
import { deleteTransformerList, getTransformerList } from '@/api/api/electricity'
// 查询参数
const searchQuery = reactive({
  offset: 1,
  limit: 20,
  name: '',
})
// // 查询时间段范围
// const TimeRanges = ref()
// // 监听时间段范围
// watch(() => TimeRanges.value, (newVal: string[]) => {
//   if (newVal && newVal.length) {
//     searchQuery.startTime = newVal[0]
//     searchQuery.endTime = newVal[1]
//   }
// }, { deep: true })
// table表格loading
const loadingTable = ref(true)
// table列表
const columns = ref([
  { text: '名称', value: 'name', align: 'center' },
  { text: '型号', value: 'model', align: 'center' },
  { text: '安装位置', value: 'installPosition', align: 'center' },
  { text: '运行状态', value: 'runningState', align: 'center' },
  { text: '额定容量', value: 'mvaRate', align: 'center' },
  { text: '最高电压等级', value: 'voltageType', align: 'center' },
  { text: '	投运日期', value: 'operateDate', align: 'center' },
  { text: '	退役日期', value: 'expiryDate', align: 'center' },
])
const total = ref<number>(0)
// table列表数据
const list = ref<any[]>([])
// 获取数据列表
const fetchDataList = () => {
  loadingTable.value = true
  getTransformerList(searchQuery).then((res) => {
    list.value = res.data.rows
    total.value = res.data.total
    loadingTable.value = false
  })
}
// 搜索
const search = () => {
  fetchDataList()
}
// 新增或编辑组件
const editRef = ref()
// 新增
const add = () => {
  editRef.value.initDialog('create')
}
// 编辑
const edit = (row: any) => {
  console.log(row, 'row')
  editRef.value.initDialog('update', row)
}
// 删除
const del = (row: any) => {
  console.log(row, 'row')
  ElMessageBox.confirm(
    '确认删除选中的数据吗?',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteTransformerList(row.id).then((res) => {
        ElMessage({
          type: 'success',
          message: '删除成功',
        })
        search()
      })
    })
    .catch(() => {
    })
}
// 重置
const reset = () => {
  searchQuery.name = ''
  searchQuery.offset = 1
  searchQuery.limit = 20
  search()
}
const detailRef = ref()
// 查看详情
const detail = (row: any) => {
  // if (row.electricityDetail) {
  //   detailRef.value.initDialog(row)
  // }
  // else {
  //   ElMessage({
  //     type: 'info',
  //     message: '暂无内容',
  //   })
  // }
  editRef.value.initDialog('detail', row)
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  search()
}
// 表格被选中的行
const selectList = ref<any[]>([])
// 表格多选
const multiSelect = (row: any[]) => {
  selectList.value = row
}
onMounted(() => {
  search()
})
</script>

<template>
  <div>
    <div>
      <edit-list ref="editRef" @refresh="search" />
      <detail-dialog ref="detailRef" />
      <!-- 筛选条件 -->
      <search-area :need-clear="true" @search="search" @clear="reset">
        <search-item>
          <el-input v-model="searchQuery.name" placeholder="名称" clearable class="w-50 m-2 normal-input" />
        </search-item>
        <!-- <search-item>
          <el-date-picker
            v-model="TimeRanges" type="datetimerange" format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss" range-separator="至" start-placeholder="上传开始时间" end-placeholder="上传结束时间"
            clearable
          />
        </search-item> -->
      </search-area>
      <table-container>
        <template #btns-right>
          <icon-button icon="icon-add" title="新增" @click="add" />
        </template>
        <!-- 表格区域 -->
        <normal-table
          :data="list" :total="total" :columns="columns as any"
          :query="{ limit: searchQuery.limit, offset: searchQuery.offset }" :list-loading="loadingTable"
          :is-showmulti-select="true" :is-multi="true" @change="changePage" @multiSelect="multiSelect"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column label="操作" align="center" width="120">
              <template #default="{ row }">
                <el-button type="primary" link size="small" @click="edit(row)">
                  修改
                </el-button>
                <el-button type="primary" link size="small" @click="del(row)">
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </div>
  </div>
</template>
